function cwt_y=cwtAnalysis(signal,fs,frqMin,frqMax,varargin)
    

if nargin==5
    wave_name=varargin{1};
else
    wave_name='morl';
end

dt=1/fs;

NumVoices = 64;
a0 = 2^(1/NumVoices);
wavCenterFreq =5/(2*pi);        %5/(2*pi);   
minfreq = frqMin;
maxfreq = frqMax;
minscale = wavCenterFreq/(maxfreq*dt);  
maxscale = wavCenterFreq/(minfreq*dt);  
minscale = floor(NumVoices*log2(minscale));
maxscale = ceil(NumVoices*log2(maxscale));
scales = a0.^(minscale:maxscale).*dt;


cwt_y = cwtft({signal,dt},'wavelet',wave_name,'scales',scales);

% figure(figNR1)
%  args = {t,cwt_y.frequencies,abs(cwt_y.cfs).^2};
%         surf(args{:},'edgecolor','none');
%         view(0,90);
%         axis tight;
%         shading interp; colormap(parula(128));
%         h = colorbar;
%         h.Label.String = 'Power';
%         xlabel('Time'); ylabel('Hz');
%         title(Name)


%helperCWTTimeFreqPlot(cwt_y.cfs,t,cwt_y.frequencies,...
   % 'surf',Name,'Time','Hz');

% figure(figNR2)
% M=mean(abs(cwt_y.cfs),2);
% semilogx(cwt_y.frequencies,abs(M))
% title(['Avg freq respons for ' sigName])
% xlabel('Hz')
% axis([0 max(cwt_y.frequencies) min(abs(M)) max(abs(M))])

    

end

