function varargout = master_GUI(varargin)
% MASTER_GUI MATLAB code for master_GUI.fig
%      MASTER_GUI, by itself, creates a new MASTER_GUI or raises the existing
%      singleton*.
%
%      H = MASTER_GUI returns the handle to a new MASTER_GUI or the handle to
%      the existing singleton*.
%
%      MASTER_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MASTER_GUI.M with the given input arguments.
%
%      MASTER_GUI('Property','Value',...) creates a new MASTER_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before master_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to master_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help master_GUI

% Last Modified by GUIDE v2.5 16-Apr-2016 08:42:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @master_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @master_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before master_GUI is made visible.
function master_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to master_GUI (see VARARGIN)

[filename1,filepath1]=uigetfile({'*.*','All Files'},...
'Select Data File 1');
%cd(filepath1);
[pathstr,name,ext] = fileparts(filename1);
handles.fileName=name;
set(handles.text3,'String',handles.fileName)
handles.rawdata=load([filepath1 filename1]);
handles.sig1=handles.rawdata.ECG;
handles.sig2=handles.rawdata.BP;
handles.sig3=handles.rawdata.LDF;

handles.sig1_ex=handles.sig1;
handles.sig2_ex=handles.sig2;
handles.sig3_ex=handles.sig3;



handles.sig1_name='ECG';
handles.sig2_name='BP';
handles.sig3_name='LDF';

handles.time=handles.rawdata.t_min;
handles.time_ex=handles.time;
handles.start_nr=1;
handles.stop_nr=length(handles.rawdata.t_min);
handles.analysis_name='';
handles.find_peaks_flag=0;



axes(handles.axes1);
plot(handles.time,handles.sig1);
title(handles.sig1_name)
axes(handles.axes2);
plot(handles.time,handles.sig2);
title(handles.sig2_name)
axes(handles.axes3);
plot(handles.time,handles.sig3);
title(handles.sig3_name)

% Choose default command line output for master_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes master_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = master_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in sig3_popup.
function sig3_popup_Callback(hObject, eventdata, handles)
% hObject    handle to sig3_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns sig3_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sig3_popup
val=get(handles.sig3_popup,'Value');
str=get(handles.sig3_popup,'String');
switch str{val}
    case 'Signal3'
        handles.sig3=handles.sig3;
    case 'ECG'
        handles.sig3=handles.rawdata.ECG;
        handles.sig3_name=str{val};
    case 'BP'
        handles.sig3=handles.rawdata.BP;
        handles.sig3_name=str{val};
    case 'LDF'
        handles.sig3=handles.rawdata.LDF;
        handles.sig3_name=str{val};
    case 'HRV'
        handles.sig3=handles.rawdata.HRV;
        handles.sig3_name=str{val};
    case 'SYS'
        handles.sig3=handles.rawdata.SYS;
        handles.sig3_name=str{val};
    case 'DIA'
        handles.sig3=handles.rawdata.DIA;
        handles.sig3_name=str{val};
        
end
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function sig3_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sig3_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in sig2_popup.
function sig2_popup_Callback(hObject, eventdata, handles)
% hObject    handle to sig2_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns sig2_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sig2_popup
val=get(handles.sig2_popup,'Value');
str=get(handles.sig2_popup,'String');
switch str{val}
    case 'Signal2'
        handles.sig2=handles.sig2;
    case 'ECG'
        handles.sig2=handles.rawdata.ECG;
        handles.sig2_name=str{val};
    case 'BP'
        handles.sig2=handles.rawdata.BP;
        handles.sig2_name=str{val};
    case 'LDF'
        handles.sig2=handles.rawdata.LDF;
        handles.sig2_name=str{val};
    case 'HRV'
        handles.sig2=handles.rawdata.HRV;
        handles.sig2_name=str{val};
    case 'SYS'
        handles.sig2=handles.rawdata.SYS;
        handles.sig2_name=str{val};
    case 'DIA'
        handles.sig2=handles.rawdata.DIA;
        handles.sig2_name=str{val};
end
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function sig2_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sig2_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in sig1_popup.
function sig1_popup_Callback(hObject, eventdata, handles)
% hObject    handle to sig1_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns sig1_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from sig1_popup
val=get(handles.sig1_popup,'Value');
str=get(handles.sig1_popup,'String');
switch str{val}
    case 'Signal1'
        handles.sig1=handles.sig1;
    case 'ECG'
        handles.sig1=handles.rawdata.ECG;
        handles.sig1_name=str{val};
    case 'BP'
        handles.sig1=handles.rawdata.BP;
        handles.sig1_name=str{val};
    case 'LDF'
        handles.sig1=handles.rawdata.LDF;
        handles.sig1_name=str{val};
    case 'HRV'
        handles.sig1=handles.rawdata.HRV;
        handles.sig1_name=str{val};
    case 'SYS'
        handles.sig1=handles.rawdata.SYS;
        handles.sig1_name=str{val};
    case 'DIA'
        handles.sig1=handles.rawdata.DIA;
        handles.sig1_name=str{val};
end
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function sig1_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sig1_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function stop_min_Callback(hObject, eventdata, handles)
% hObject    handle to stop_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of stop_min as text
%        str2double(get(hObject,'String')) returns contents of stop_min as a double
val=get(hObject,'Value');
str=get(hObject,'String');
stop_nr=find(handles.time>=str2double(str));
handles.stop_nr=stop_nr(1);
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function stop_min_CreateFcn(hObject, ~, handles)
% hObject    handle to stop_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function start_min_Callback(hObject, eventdata, handles)
% hObject    handle to start_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of start_min as text
%        str2double(get(hObject,'String')) returns contents of start_min as a double
val=get(hObject,'Value');
str=get(hObject,'String');
start_nr=find(handles.time>=str2double(str));
handles.start_nr=start_nr(1);
guidata(hObject,handles)

% --- Executes during object creation, after setting all properties.
function start_min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to start_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in fft_button.
function fft_button_Callback(hObject, eventdata, handles)
% hObject    handle to fft_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic
set(handles.figure1, 'pointer', 'watch')
drawnow;

handles.analysis_name='FFT';
axes(handles.axes4);
fft_plot(handles.sig1_ex,handles.rawdata.fs,200*1024,handles.sig1_name)
axis([0.01 10 -inf inf])
axes(handles.axes5);
fft_plot(handles.sig2_ex,handles.rawdata.fs,200*1024,handles.sig2_name)
axis([0.01 10 -inf inf])
axes(handles.axes6);
fft_plot(handles.sig3_ex,handles.rawdata.fs,200*1024,handles.sig3_name)
axis([0.01 10 -inf inf])

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)
toc

% --- Executes on button press in cwt_mean_button.

function cwt_mean_button_Callback(hObject, eventdata, handles)
% hObject    handle to cwt_mean_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic
set(handles.figure1, 'pointer', 'watch')
drawnow;
handles.analysis_name='CWT_mean';
[sig1_w,t_w,fs_w,lvl3]=wavedecom(handles.sig1_ex,handles.time_ex,handles.rawdata.fs,6,'db4');
[sig2_w,t_w,fs_w,lvl3]=wavedecom(handles.sig2_ex,handles.time_ex,handles.rawdata.fs,6,'db4');
[sig3_w,t_w,fs_w,lvl3]=wavedecom(handles.sig3_ex,handles.time_ex,handles.rawdata.fs,6,'db4');

handles.cwt1=cwtAnalysis(sig1_w,fs_w,0.004,2,'morl');
handles.m1=mean(abs(handles.cwt1.cfs),2);
handles.cwt2=cwtAnalysis(sig2_w,fs_w,0.004,2,'morl');
handles.m2=mean(abs(handles.cwt2.cfs),2);
handles.cwt3=cwtAnalysis(sig3_w,fs_w,0.004,2,'morl');
handles.m3=mean(abs(handles.cwt3.cfs),2);

axes(handles.axes4);
semilogx(handles.cwt1.frequencies,handles.m1)
title(['CWT of ' handles.sig1_name ' ' num2str(handles.time(handles.start_nr)) '-' num2str(handles.time(handles.stop_nr))])
axes(handles.axes5);
semilogx(handles.cwt2.frequencies,handles.m2)
title(['CWT of ' handles.sig2_name ' ' num2str(handles.time(handles.start_nr)) '-' num2str(handles.time(handles.stop_nr))])
axes(handles.axes6);
semilogx(handles.cwt3.frequencies,handles.m3)
title(['CWT of ' handles.sig3_name ' ' num2str(handles.time(handles.start_nr)) '-' num2str(handles.time(handles.stop_nr))])
set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)
toc


% --- Executes on button press in load_file.
function load_file_Callback(hObject, eventdata, handles)
% hObject    handle to load_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
clear handles.rawdata
clear handles.cwt1 handles.cwt2 handles.cwt3 handles.m1 handles.m2 handles.m3

[filename1,filepath1]=uigetfile({'*.*','All Files'},...
'Select Data File 1');
handles.rawdata=load([filepath1 filename1]);
[pathstr,name,ext] = fileparts(filename1);
handles.fileName=name;
set(handles.text3,'String',handles.fileName)

handles.sig1=handles.rawdata.ECG;
handles.sig2=handles.rawdata.BP;
handles.sig3=handles.rawdata.LDF;

handles.sig1_name='ECG';
handles.sig2_name='BP';
handles.sig3_name='LDF';

handles.time=handles.rawdata.t_min;
handles.time_ex=handles.time;
handles.start_nr=1;
handles.stop_nr=length(handles.rawdata.t_min);
handles.analysis_name='';
handles.find_peaks_flag=0;

reset_Callback(hObject, eventdata, handles)
update_Callback(hObject, eventdata, handles)

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)


% --- Executes on button press in update.
function update_Callback(hObject, eventdata, handles)
% hObject    handle to update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'pointer', 'watch')
drawnow;
 
handles.time_ex=handles.time(handles.start_nr:handles.stop_nr);
handles.sig1_ex=handles.sig1(handles.start_nr:handles.stop_nr);
handles.sig2_ex=handles.sig2(handles.start_nr:handles.stop_nr);
handles.sig3_ex=handles.sig3(handles.start_nr:handles.stop_nr);

axes(handles.axes1);
plot(handles.time_ex,handles.sig1_ex);
title(handles.sig1_name)
axes(handles.axes2);
plot(handles.time_ex,handles.sig2_ex);
title(handles.sig2_name)
axes(handles.axes3);
plot(handles.time_ex,handles.sig3_ex);
title(handles.sig3_name)

set(handles.figure1, 'pointer', 'arrow')
guidata(hObject,handles)


% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clear handles.sig1 handles.sig2 handles.sig3
clear handles.sig1_ex handles.sig2_ex handles.sig3_ex handles.time_ex



handles.sig1=handles.rawdata.ECG;
handles.sig2=handles.rawdata.BP;
handles.sig3=handles.rawdata.LDF;

handles.sig1_name='ECG';
handles.sig2_name='BP';
handles.sig3_name='LDF';

handles.time=handles.rawdata.t_min;
handles.start_nr=1;
handles.stop_nr=length(handles.rawdata.t_min);
set(handles.start_min,'String','-')
set(handles.stop_min,'String','-')
set(handles.sub_power,'String','Sub band powers')
set(handles.sub_power2,'String','Sub band powers')
set(handles.sub_power3,'String','Sub band powers')
set(handles.sig1_popup,'Value',1)
set(handles.sig2_popup,'Value',1)
set(handles.sig3_popup,'Value',1)
cla(handles.axes4),cla(handles.axes5),cla(handles.axes6)

update_Callback(hObject, eventdata, handles);

guidata(hObject,handles)



function fileName_Callback(hObject, eventdata, handles)
% hObject    handle to fileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fileName as text
%        str2double(get(hObject,'String')) returns contents of fileName as a double
set(hObject,'String',handles.fileName)

% --- Executes during object creation, after setting all properties.
function fileName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cwt_analysis.
function cwt_analysis_Callback(hObject, eventdata, handles)
% hObject    handle to cwt_analysis (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic
set(handles.figure1, 'pointer', 'watch')
drawnow;

handles.analysis_name='CWT';
if (length(handles.sig1_ex)>6*60*handles.rawdata.fs)
    qstring = {'This may take a long time to compute.' 'Do you wish to continue?'};
    choice = questdlg(qstring,'Warning',...
        'Yes','No','No');
    %uiwait()
    if strcmp('Yes',choice)
          
    [sig1_w,t_w,fs_w,lvl3]=wavedecom(handles.sig1_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    [sig2_w,t_w,fs_w,lvl3]=wavedecom(handles.sig2_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    [sig3_w,t_w,fs_w,lvl3]=wavedecom(handles.sig3_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    cwt1=cwtAnalysis(sig1_w,fs_w,0.01,2);
    cwt2=cwtAnalysis(sig2_w,fs_w,0.01,2);
    cwt3=cwtAnalysis(sig3_w,fs_w,0.01,2);

    axes(handles.axes4);
    cwt_plot1(cwt1,t_w,[' of ' handles.sig1_name])
    axes(handles.axes5);
    cwt_plot1(cwt2,t_w,[' of ' handles.sig2_name])
    axes(handles.axes6);
    cwt_plot1(cwt3,t_w,[' of ' handles.sig3_name])
    end
    
else
    [sig1_w,t_w,fs_w,lvl3]=wavedecom(handles.sig1_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    [sig2_w,t_w,fs_w,lvl3]=wavedecom(handles.sig2_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    [sig3_w,t_w,fs_w,lvl3]=wavedecom(handles.sig3_ex,handles.time_ex,handles.rawdata.fs,5,'db4');
    cwt1=cwtAnalysis(sig1_w,fs_w,0.01,2);
    cwt2=cwtAnalysis(sig2_w,fs_w,0.01,2);
    cwt3=cwtAnalysis(sig3_w,fs_w,0.01,2);

    axes(handles.axes4);
    cwt_plot1(cwt1,t_w,[' of ' handles.sig1_name])
    axes(handles.axes5);
    cwt_plot1(cwt2,t_w,[' of ' handles.sig2_name])
    axes(handles.axes6);
    cwt_plot1(cwt3,t_w,[' of ' handles.sig3_name])
end    
    
    set(handles.figure1, 'pointer', 'arrow') 
    guidata(hObject,handles)
    toc
    


% --- Executes on button press in saveFig_button.
function saveFig_button_Callback(hObject, eventdata, handles)
% hObject    handle to saveFig_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.figure1, 'Pointer', 'watch')
drawnow;


folder_name = uigetdir(cd,'Choose folder for saving');

fpath=[folder_name '\' handles.fileName];
if exist(fpath,'dir')
 
 else
     mkdir(fpath)
end


h1=figure(11);
plot(handles.time_ex,handles.sig1_ex);
title(handles.sig1_name)
xlabel('Time [min]')
axis('tight')
saveas(h1,[fpath '\' handles.sig1_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
ax_pos=h1.CurrentAxes.Position;
close 11

if ~exist([fpath '\' handles.sig2_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
h2=figure(2);
plot(handles.time_ex,handles.sig2_ex);
title(handles.sig2_name)
xlabel('Time [min]')
axis('tight')
saveas(h2,[fpath '\' handles.sig2_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
close 2
end

if ~exist([fpath '\' handles.sig3_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
h3=figure(3);
plot(handles.time_ex,handles.sig3_ex);
title(handles.sig3_name)
xlabel('Time [min]')
axis('tight')
saveas(h3,[fpath '\' handles.sig3_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
close 3
end

if ~exist([fpath '\' handles.sig1_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
h4=figure(4);
copyobj(handles.axes4,h4)
set(h4.CurrentAxes,'Position',ax_pos)
if strcmp(handles.analysis_name,'FFT') || strcmp(handles.analysis_name,'CWT_mean') 
    xlabel('Hz')
end
saveas(h4,[fpath '\' handles.sig1_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
close 4
end

if ~exist([fpath '\' handles.sig2_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
h5=figure(5);
copyobj(handles.axes5,h5)
set(h5.CurrentAxes,'Position',ax_pos)
if strcmp(handles.analysis_name,'FFT') || strcmp(handles.analysis_name,'CWT_mean') 
    xlabel('Hz')
end
saveas(h5,[fpath '\' handles.sig2_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
close 5
end

if ~exist([fpath '\' handles.sig3_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
h6=figure(6);
copyobj(handles.axes6,h6)
set(h6.CurrentAxes,'Position',ax_pos)
if strcmp(handles.analysis_name,'FFT') || strcmp(handles.analysis_name,'CWT_mean') 
    xlabel('Hz')
end
saveas(h6,[fpath '\' handles.sig3_name '_' handles.analysis_name '_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.fig'])
close 6
end

if handles.find_peaks_flag
    P1=handles.P1;
    P2=handles.P2;
    P3=handles.P3;
    
    peak_sig1=handles.peak_val1;
    peak_sig2=handles.peak_val2;
    peak_sig3=handles.peak_val3;
    
    peak_freq_sig1=handles.peak_freq1;
    peak_freq_sig2=handles.peak_freq2;
    peak_freq_sig3=handles.peak_freq3;
    
    sig1_P=handles.P_sig1;
    sig2_P=handles.P_sig2;
    sig3_P=handles.P_sig3; 
    
    Sig_names={handles.sig1_name; handles.sig2_name; handles.sig3_name};
    
    save([fpath '\sub_band_powers_' num2str(round(handles.time(handles.start_nr))) '_'...
     num2str(round(handles.time(handles.stop_nr))) '.mat'],'P1','P2','P3','peak_sig1','peak_sig2','peak_sig3'...
     ,'peak_freq_sig1','peak_freq_sig2','peak_freq_sig3','Sig_names'...
     ,'sig1_P','sig2_P','sig3_P')
end

set(handles.figure1, 'pointer', 'arrow') 
h = msgbox('Figures and sub band powers are saved');



% --- Executes on button press in rem_out_button.
function rem_out_button_Callback(hObject, eventdata, handles)
% hObject    handle to rem_out_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sig1_mean=mean(handles.sig1_ex);
sig2_mean=mean(handles.sig2_ex);
handles.sig1_ex=handles.sig1_ex-sig1_mean;
handles.sig2_ex=handles.sig2_ex-sig2_mean;

handles.sig1_ex(find(abs(handles.sig1_ex)>(4*std(handles.sig1_ex)+mean(handles.sig1_ex))))=mean(handles.sig1_ex);
handles.sig2_ex(find(abs(handles.sig2_ex)>(4*std(handles.sig2_ex)+mean(handles.sig2_ex))))=mean(handles.sig2_ex);
handles.sig3_ex(find(abs(handles.sig3_ex)>(2*std(handles.sig3_ex)+mean(handles.sig3_ex))))=mean(handles.sig3_ex);

handles.sig1_ex=handles.sig1_ex+sig1_mean;
handles.sig2_ex=handles.sig2_ex+sig2_mean;

axes(handles.axes1);
plot(handles.time_ex,handles.sig1_ex);
title(handles.sig1_name)
axes(handles.axes2);
plot(handles.time_ex,handles.sig2_ex);
title(handles.sig2_name)
axes(handles.axes3);
plot(handles.time_ex,handles.sig3_ex);
title(handles.sig3_name)

guidata(hObject,handles)


% --- Executes on button press in findpeaks_button.
function findpeaks_button_Callback(hObject, eventdata, handles)
% hObject    handle to findpeaks_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if strcmp(handles.analysis_name,'CWT_mean')
    handles.find_peaks_flag=1;
[hr1_peak,locs_hr1,hr1_freq,M1_hr,resp1_peak,locs_resp1,resp1_freq,M1_resp,myo1_peak,locs_myo1,myo1_freq,M1_myo,...
    neur1_peak,locs_neur1,neur1_freq,M1_neur,eMeta1_peak,locs_eMeta1,eMeta1_freq,M1_eMeta,VLF1_peak,locs_VLF1,VLF1_freq,M1_VLF] = findPeaks_CWT(handles.cwt1,handles.m1);
[hr2_peak,locs_hr2,hr2_freq,M2_hr,resp2_peak,locs_resp2,resp2_freq,M2_resp,myo2_peak,locs_myo2,myo2_freq,M2_myo,...
    neur2_peak,locs_neur2,neur2_freq,M2_neur,eMeta2_peak,locs_eMeta2,eMeta2_freq,M2_eMeta,VLF2_peak,locs_VLF2,VLF2_freq,M2_VLF] = findPeaks_CWT(handles.cwt2,handles.m2);
[hr3_peak,locs_hr3,hr3_freq,M3_hr,resp3_peak,locs_resp3,resp3_freq,M3_resp,myo3_peak,locs_myo3,myo3_freq,M3_myo,...
    neur3_peak,locs_neur3,neur3_freq,M3_neur,eMeta3_peak,locs_eMeta3,eMeta3_freq,M3_eMeta,VLF3_peak,locs_VLF3,VLF3_freq,M3_VLF] = findPeaks_CWT(handles.cwt3,handles.m3);

handles.P_sig1=sum(handles.m1.^2);
handles.P_sig2=sum(handles.m2.^2);
handles.P_sig3=sum(handles.m3.^2);
P1_hr=rms(M1_hr).^2; P1_resp=rms(M1_resp).^2; P1_myo=rms(M1_myo).^2; P1_neur=rms(M1_neur).^2; P1_eMeta=rms(M1_eMeta).^2; P1_VLF=rms(M1_VLF).^2;
P2_hr=rms(M2_hr).^2; P2_resp=rms(M2_resp).^2; P2_myo=rms(M2_myo).^2; P2_neur=rms(M2_neur).^2; P2_eMeta=rms(M2_eMeta).^2; P2_VLF=rms(M2_VLF.^2);
P3_hr=rms(M3_hr).^2; P3_resp=rms(M3_resp).^2; P3_myo=rms(M3_myo).^2; P3_neur=rms(M3_neur).^2; P3_eMeta=rms(M3_eMeta).^2; P3_VLF=rms(M3_VLF).^2;

handles.P1=[P1_hr;P1_resp;P1_myo;P1_neur;P1_eMeta; P1_VLF];
handles.P2=[P2_hr;P2_resp;P2_myo;P2_neur;P2_eMeta; P2_VLF];
handles.P3=[P3_hr;P3_resp;P3_myo;P3_neur;P3_eMeta; P3_VLF];

% plot peaks
axes(handles.axes4);hold on
if ~isempty(locs_hr1); plot(hr1_freq(locs_hr1(1)),hr1_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_resp1); plot(resp1_freq(locs_resp1(1)),resp1_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_myo1); plot(myo1_freq(locs_myo1(1)),myo1_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_neur1); plot(neur1_freq(locs_neur1(1)),neur1_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_eMeta1); plot(eMeta1_freq(locs_eMeta1(1)),eMeta1_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_VLF1); plot(VLF1_freq(locs_VLF1(1)),VLF1_peak(1),'rv','MarkerFaceColor','r'); end
hold off

axes(handles.axes5);hold on
if ~isempty(locs_hr2); plot(hr2_freq(locs_hr2(1)),hr2_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_resp2);plot(resp2_freq(locs_resp2(1)),resp2_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_myo2);plot(myo2_freq(locs_myo2(1)),myo2_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_neur2);plot(neur2_freq(locs_neur2(1)),neur2_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_eMeta2);plot(eMeta2_freq(locs_eMeta2(1)),eMeta2_peak(1),'rv','MarkerFaceColor','r');end
if ~isempty(locs_VLF2);plot(VLF2_freq(locs_VLF2(1)),VLF2_peak(1),'rv','MarkerFaceColor','r');end
hold off

axes(handles.axes6);hold on
if ~isempty(locs_hr3); plot(hr3_freq(locs_hr3(1)),hr3_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_resp3); plot(resp3_freq(locs_resp3(1)),resp3_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_myo3); plot(myo3_freq(locs_myo3(1)),myo3_peak(1),'rv','MarkerFaceColor','r'); end 
if ~isempty(locs_neur3); plot(neur3_freq(locs_neur3(1)),neur3_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_eMeta3); plot(eMeta3_freq(locs_eMeta3(1)),eMeta3_peak(1),'rv','MarkerFaceColor','r'); end
if ~isempty(locs_VLF3); plot(VLF3_freq(locs_VLF3(1)),VLF3_peak(1),'rv','MarkerFaceColor','r'); end
hold off

% Sort values for saving
if isempty(hr1_peak); hr1_peak=0; hr1_f=0; else hr1_f=hr1_freq(locs_hr1(1)) ;end
if isempty(hr2_peak); hr2_peak=0; hr2_f=0; else hr2_f=hr2_freq(locs_hr2(1)) ;end
if isempty(hr3_peak); hr3_peak=0; hr3_f=0; else hr3_f=hr3_freq(locs_hr3(1)) ;end
if isempty(resp1_peak); resp1_peak=0; resp1_f=0; else resp1_f=resp1_freq(locs_resp1(1)) ;end
if isempty(resp2_peak); resp2_peak=0; resp2_f=0; else resp2_f=resp2_freq(locs_resp2(1)) ;end
if isempty(resp3_peak); resp3_peak=0; resp3_f=0; else resp3_f=resp3_freq(locs_resp3(1)) ;end
if isempty(myo1_peak); myo1_peak=0; myo1_f=0; else myo1_f=myo1_freq(locs_myo1(1)) ;end
if isempty(myo2_peak); myo2_peak=0; myo2_f=0; else myo2_f=myo2_freq(locs_myo2(1)) ;end
if isempty(myo3_peak); myo3_peak=0; myo3_f=0; else myo3_f=myo3_freq(locs_myo3(1)) ;end
if isempty(neur1_peak); neur1_peak=0; neur1_f=0; else neur1_f=neur1_freq(locs_neur1(1)) ;end
if isempty(neur2_peak); neur2_peak=0; neur2_f=0; else neur2_f=neur2_freq(locs_neur2(1)) ;end
if isempty(neur3_peak); neur3_peak=0; neur3_f=0; else neur3_f=neur3_freq(locs_neur3(1)) ;end
if isempty(eMeta1_peak); eMeta1_peak=0; eMeta1_f=0; else eMeta1_f=eMeta1_freq(locs_eMeta1(1)) ;end
if isempty(eMeta2_peak); eMeta2_peak=0; eMeta2_f=0; else eMeta2_f=eMeta2_freq(locs_eMeta2(1)) ;end
if isempty(eMeta3_peak); eMeta3_peak=0; eMeta3_f=0; else eMeta3_f=eMeta3_freq(locs_eMeta3(1)) ;end

if isempty(VLF1_peak); VLF1_peak=0; VLF1_f=0; else VLF1_f=VLF1_freq(locs_VLF1(1)) ;end
if isempty(VLF2_peak); VLF2_peak=0; VLF2_f=0; else VLF2_f=VLF2_freq(locs_VLF2(1)) ;end
if isempty(VLF3_peak); VLF3_peak=0; VLF3_f=0; else VLF3_f=VLF3_freq(locs_VLF3(1)) ;end



handles.peak_val1=[hr1_peak(1); resp1_peak(1); myo1_peak(1); neur1_peak(1); eMeta1_peak(1); VLF1_peak(1)];
handles.peak_val2=[hr2_peak(1); resp2_peak(1); myo2_peak(1); neur2_peak(1); eMeta2_peak(1); VLF2_peak(1)];
handles.peak_val3=[hr3_peak(1); resp3_peak(1); myo3_peak(1); neur3_peak(1); eMeta3_peak(1); VLF3_peak(1)];

handles.peak_freq1=[hr1_f; resp1_f; myo1_f; neur1_f;eMeta1_f; VLF1_f];
handles.peak_freq2=[hr2_f; resp2_f; myo2_f; neur2_f;eMeta2_f; VLF2_f];
handles.peak_freq3=[hr3_f; resp3_f; myo3_f; neur3_f;eMeta3_f; VLF3_f];

set(handles.sub_power,'String',{'Sub band powers',num2str(P1_hr),num2str(P1_resp),num2str(P1_myo),num2str(P1_neur),num2str(P1_eMeta),num2str(P1_VLF)});
set(handles.sub_power2,'String',{'Sub band powers',num2str(P2_hr),num2str(P2_resp),num2str(P2_myo),num2str(P2_neur),num2str(P2_eMeta),num2str(P2_VLF)});
set(handles.sub_power3,'String',{'Sub band powers',num2str(P3_hr),num2str(P3_resp),num2str(P3_myo),num2str(P3_neur),num2str(P3_eMeta),num2str(P3_VLF)});


else
    h = msgbox('Do the CWT mean analysis first');
end
guidata(hObject,handles)