load('Test_20160204.mat')
BP_in=data(datastart(3,1):dataend(3,1));
BP_in_2=data(datastart(3,2):dataend(3,2));
BP_in=[BP_in BP_in_2];                  %invasive Blood preasure
fs1=samplerate(1,1);

load('NK_test1.mat')
BP_nin=data(dataend(2)+1:dataend(3));   %noninvasive Blood preasure
fs2=samplerate(3);

range=[20 300];

med_plot(BP_in,'Invasive BP',fs1,BP_nin,'Noninvasive BP',fs2,range)
[BP_in,t1,fs1,sig_name1]=signal_exc(BP_in,'Invasive BP',range,fs1);
[BP_nin,t2,fs2,sig_name2]=signal_exc(BP_nin,'Noninvasive BP',range,fs2);

[BP1_w,t1_w,fs1_w,lvl1]=wavedecom(BP_in,t1,fs1,5,'db4');
[BP2_w,t2_w,fs2_w,lvl2]=wavedecom(BP_nin,t2,fs2,4,'db4');

%%
figure(6)
wavedec_plot(BP_in,t1,sig_name1,BP1_w/lvl1,t1_w,lvl1,range)
figure(7)
wavedec_plot(BP_nin,t2,sig_name2,BP2_w/lvl2,t2_w,lvl2,range)

%% FFT

figure
subplot(2,1,1)
fft_plot(BP_in,fs1,100*1024,'BP invasive')
subplot(2,1,2)
fft_plot(BP_nin,fs2,50*1024,'BP noninvasive')



%% CWT

cwt_1=cwtAnalysis(BP1_w,fs1_w,0.01,3);
cwt_plot1(cwt_1,t1_w,sig_name1,2)

cwt_2=cwtAnalysis(BP2_w,fs2_w,0.01,3);
cwt_plot1(cwt_2,t2_w,sig_name2,3)

M1=mean(abs(cwt_1.cfs),2);  %Invasive
figure(4)
semilogx(cwt_1.frequencies,abs(M1))
title(['Frequency respons for ' sig_name1])
axis('tight')

M2=mean(abs(cwt_2.cfs),2);  %Non invasive
figure(5)
semilogx(cwt_2.frequencies,abs(M2))
title(['Frequency respons for ' sig_name2])
axis('tight')
