clear
close all

[filename1,filepath1]=uigetfile({'*.*','All Files'},...
'Select Data File 1');
load([filepath1 filename1]);

[pathstr,name,ext] = fileparts(filename1);
 
 min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;
 
 
%% filtering
    ECG_origin=ECG;
    ECG(find(abs(ECG)>(7*std(ECG)+mean(ECG))))=mean(ECG);
    ECG(find(ECG<(mean(ECG)-4*std(ECG))))=mean(ECG);
    
%         rp = 1;             % Passband ripple
%         rs = 6;             % Stopband ripple
%         f = [0.5 0.7];      % Cutoff frequencies
%         a = [0 1];          % Desired amplitudes
% 
%         dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
%         [m,fo,ao,w] = firpmord(f,a,dev,fs);
%         b = firpm(m,fo,ao,w);
%         x_f=filter(b,1,ECG);
%         delay = mean(grpdelay(b));
%         t_x=t_min;
%         t_f=t_x(1:end-delay);
%         x_f(1:delay)=[];
%         ECG_f=x_f;
%         
%         rp = 1;             % Passband ripple
%         rs = 6;             % Stopband ripple
%         f = [40 42];      % Cutoff frequencies
%         a = [1 0];          % Desired amplitudes
% 
%         dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
%         [m,fo,ao,w] = firpmord(f,a,dev,fs);
%         b = firpm(m,fo,ao,w);
%         x_f=filter(b,1,ECG_f);
%         delay = ceil(mean(grpdelay(b)));
%         t_f=t_f(1:end-delay);
%         x_f(1:delay)=[];
%         ECG_f=x_f;
        
        

%         figure(1)
%         subplot(2,1,1)
%         plot(t_min,ECG_origin)
%         title('Orginal ECG')
%         subplot(2,1,2)
%         plot(t_min,ECG)
%         title('Filtered ECG')
        
 %ECG=ECG_f;
 %t_min=t_f;
        
 %% Find R peaks and HRV

for n=1:1
[~,locs_R]=findHRV(ECG,fs,200);

figure(2)
subplot(2,2,1)
hold on
plot(t_min,ECG), grid
plot(t_min(locs_R),ECG(locs_R),'rv','MarkerFaceColor','r');
axis('tight')
hold off
xlabel('Time [min]')
title('ECG with R peak detection')

for i=1:length(locs_R)-1
    RR(i)=(locs_R(i+1)-locs_R(i));
end

%figure
subplot(2,2,2)
plot(t_min(locs_R(1:end-1)),1./(RR./fs)), grid, hold on;
if range(1)<min10 && range(2)>min10; plot([min10 min10],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min20 && range(2)>min20; plot([min20 min20],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min30 && range(2)>min30; plot([min30 min30],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min40 && range(2)>min40; plot([min40 min40],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
title('HRV')
xlabel('Time [min]')
ylabel('Hz')
axis('tight')
hold off

%figure
subplot(2,2,3)
histogram((RR./fs)), grid
xlabel('Sampling interval [sec]')
ylabel('RR distribution')

y=RR(2:end)./fs;
x=RR(1:end-1)./fs;

meany=mean(y); meanx=mean(x);


%SD1
SD1 = std(y-x)/sqrt(2)

%SD2
SD2 = std(y+x)/sqrt(2)

majorAxis = 3*SD1;
minorAxis = 3*SD2;
centerX = meanx;
centerY = meany;
orientation = -45;

theta = 0 : 0.05 : 2*pi;
orientation=orientation*pi/180;
xx = (majorAxis/2) * sin(theta) + centerX;
yy = (minorAxis/2) * cos(theta) + centerY;

xx2 = (xx-centerX)*cos(orientation) - (yy-centerY)*sin(orientation) + centerX;
yy2 = (xx-centerX)*sin(orientation) + (yy-centerY)*cos(orientation) + centerY;



%figure
subplot(2,2,4)
scatter(RR(2:end)./fs,RR(1:end-1)./fs);
hold on
plot(meanx,meany,'r*','MarkerSize',10)
plot(xx2,yy2,'LineWidth', 3)

hold off
xlabel('RR_n [sec]')
ylabel('RR_{n+1} [sec]')


end

%%
dessert=0;
% Construct a questdlg with three options
choice = questdlg('Would you like a to save plots?', ...
	'Yes', ...
	'No');
% Handle response
switch choice
    case 'Yes'
        disp([choice ' coming right up.'])
        dessert = 1;
    case 'No'
        disp([choice ' coming right up.'])
        dessert = 0;
end

if dessert
    h =  findobj('type','figure');
    folder_name = uigetdir(cd,['Choose folder for saving: ' name]);
    for i =1:length(h)
        set(h(i), 'Position', get(0, 'Screensize'))
        savefig(h(i),[folder_name '\' name num2str(i) '.fig']);
        print(h(i),'-dpng',[folder_name '\' name '_' num2str(i)]);
        close(h(i))
    end
    save([folder_name '\' name '.mat'],'SD1','SD2')
end
disp(name)