load('Test_20160204.mat')
ECG=data(1:dataend(1,1));
ECG_2=data(datastart(1,2):dataend(1,2));
ECG=[ECG ECG_2];

ECG=ECG-mean(ECG);

fs=samplerate(1,1);

t=0:1/fs:length(ECG)/fs-1/fs;
min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;

%% compare noiseless with noisy segment

figure
subplot(3,1,1)
plot(t(8*60*fs:min10*fs)./60,ECG(8*60*fs:min10*fs))
xlabel('t[min]')
axis('tight')
title('ECG')
subplot(3,1,2)
plot(t(min10*fs:12*60*fs)./60,ECG(min10*fs:12*60*fs))
xlabel('t[min]')
axis('tight')
title('ECG with motion artifact')
subplot(3,1,3)
plot(t(min10*fs:10.5*60*fs)./60,ECG(min10*fs:10.5*60*fs))
axis('tight')
xlabel('t[min]')


figure
subplot(2,1,1)
fft_plot(ECG(5*60:min10*fs),fs,100*1024,'ECG')
subplot(2,1,2)
fft_plot(ECG(min10*fs:15*60*fs),fs,100*1024,'ECG with motion artifact')



%% high pass filter
%plot(t(611*fs:625*fs),ECG(611*fs:625*fs))
x=ECG(611*fs:625*fs);
t_x=t(611*fs:625*fs);

x=x-mean(x);

rp = 1;             % Passband ripple
rs = 6;             % Stopband ripple
f = [0.5 0.7];      % Cutoff frequencies
a = [0 1];          % Desired amplitudes

dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
[n,fo,ao,w] = firpmord(f,a,dev,fs);
b1 = firpm(n,fo,ao,w);
figure
freqz(b1,1,1024,fs)

 x_f=filter(b1,1,x);
 
% 
% rp = 1;             % Passband ripple
% rs = 12;             % Stopband ripple
% f = [19 20];      % Cutoff frequencies
% a = [1 0];          % Desired amplitudes
% 
% dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
% [n,fo,ao,w] = firpmord(f,a,dev,fs);
% b2 = firpm(n,fo,ao,w);
%  figure
%  freqz(b2,1,1024,fs)
% 
% x_f=filter(b2,1,x_f);


delay = mean(grpdelay(b1));
%delay2 = mean(grpdelay(b2));
%delay=delay1+delay2;

t_x=t_x(1:end-delay);
x_f(1:delay)=[];


figure
subplot(2,1,1)
plot(t_x,x(1:end-delay))
xlabel('t (min)')
title('Original signal')
subplot(2,1,2)
plot(t_x,x_f)
xlabel('t (min)')
title('Filtered signal')

figure
subplot(2,1,1)
fft_plot(x,fs,100*1024,'ECG')
subplot(2,1,2)
fft_plot(x_f,fs,100*1024,'ECG filtered')

%Putting the segment back in the singal
% ECG(611*fs:625*fs-delay)=x_f+mean(ECG(500*fs:600*fs));
% 
% figure
% plot(t(1:min20*fs),ECG(1:min20*fs))
% xlabel('t (min)')
% title('Filtered signal part put back in the original')

[ECG_w,t1_w,fs1_w,lvl1]=wavedecom(ECG(1:min20*fs),t(1:min20*fs),fs,5,'db4');
%%
cwt_3=cwtAnalysis(ECG_w,fs1_w,0.01,3);
cwt_plot1(cwt_3,t1_w,'ECG after filter',9)


%%
%removing trend
%samples 612*fs:616*fs
ECG_old=ECG;

opol = 10;
[p,s,mu] = polyfit(t(612*fs:616*fs),ECG(612*fs:616*fs),opol);
f_y1 = polyval(p,t(612*fs:616*fs),[],mu);
ECG(612*fs:616*fs) = ECG(612*fs:616*fs) - f_y1 + mean(f_y1);
ECG(612*fs:616*fs)=detrend(ECG(612*fs:616*fs))+median(ECG);

opol = 10;
[p,s,mu] = polyfit(t(621*fs:623*fs),ECG(621*fs:623*fs),opol);
f_y = polyval(p,t(621*fs:623*fs),[],mu);
ECG(621*fs:623*fs) = ECG(621*fs:623*fs) - f_y + mean(f_y);
ECG(621*fs:623*fs)=detrend(ECG(621*fs:623*fs))+median(ECG);
ECG(616*fs:621*fs)=detrend(ECG(616*fs:621*fs))+median(ECG);
ECG(621.1*fs:627*fs)=detrend(ECG(621.1*fs:627*fs))+median(ECG);


figure
subplot(2,1,1)
plot(t(611*fs:625*fs),ECG_old(611*fs:625*fs))
xlabel('t (min)')
title('Original signal')
subplot(2,1,2)
plot(t(611*fs:625*fs),ECG(611*fs:625*fs))
xlabel('t (min)')
title('Filtered signal')

figure
subplot(2,1,1)
fft_plot(ECG_old(611*fs:625*fs),fs,100*1024,'ECG')
subplot(2,1,2)
fft_plot(ECG(611*fs:625*fs),fs,100*1024,'ECG filtered')



%%
range=[1 min20];
[ECG_exc,t,fs,sig_name]=signal_exc(ECG,'ECG',range,400);

[ECG_w,t1_w,fs1_w,lvl1]=wavedecom(ECG_exc,t,fs,5,'db4');

figure(1)
subplot(2,1,1)
plot(t,ECG_exc)
subplot(2,1,2)
plot(t1_w,smooth(ECG_w,3))

%% CWT
cwt_3=cwtAnalysis(ECG_w,fs1_w,0.01,3);
cwt_plot1(cwt_3,t1_w,'ECG filtered',2)

%% Find R peaks and HRV
range=[min10+1 min20];
[ECG_exc,t,fs,sig_name]=signal_exc(ECG,'ECG',range,400);

[~,locs_R]=findpeaks(ECG_exc,'MinPeakHeight',0.2*10^-3,'MinPeakDistance',200);

figure
hold on
plot(t,ECG_exc), grid
plot(t(locs_R),ECG_exc(locs_R),'rv','MarkerFaceColor','r');
axis('tight')
hold off
xlabel('Time [sec]')
title('ECG with R peak detection')

for i=1:length(locs_R)-1
    RR(i)=(locs_R(i+1)-locs_R(i));
end

t_rr=t(locs_R(1:end-1));
figure
plot(t_rr,1./(RR./fs)), grid, hold on;
if range(1)<min10 && range(2)>min10; plot([min10 min10],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min20 && range(2)>min20; plot([min20 min20],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min30 && range(2)>min30; plot([min30 min30],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min40 && range(2)>min40; plot([min40 min40],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
title('HRV')
xlabel('Time [sec]')
ylabel('Hz')
axis('tight')
hold off

figure
hist(1./(RR./fs)), grid
xlabel('Hz')
ylabel('RR distribution')

%% HRV spektral analysis
%interpolation
fs_hrv=4;
t_hrv=linspace(range(1),range(2),fs_hrv*(range(2)-range(1)));
hrv = interp1(t_rr,RR,t_hrv,'spline');
%hrv=(hrv-mean(hrv));
hrv=1./(hrv./fs);

nfft=100*1024;
%fs_HRV=length(RR)/(range(2)-range(1));
figure
fft_plot(hrv-mean(hrv),fs_hrv,nfft,'HRV')

cwt_1=cwtAnalysis(hrv,fs_hrv,0.003,1);
cwt_plot1(cwt_1,t_hrv,'HRV',20)

M1=mean(abs(cwt_1.cfs),2);  %HRV
figure
semilogx(cwt_1.frequencies,abs(M1))
title('Frequency respons for HRV')
axis('tight')
