load('Test_20160204.mat')
LDF=data(datastart(5,1):dataend(5,1));
LDF_2=data(datastart(5,2):dataend(5,2));
LDF=[LDF LDF_2];
LDF=LDF-mean(LDF);
fs=samplerate(1,1);
t=0:1/fs:length(LDF)/fs-1/fs;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;



%% finding freq diffrens
range=[500 500+600];
[x,t_x,fs,sig_name3]=signal_exc(LDF,'LDF',range,400);
[y,t_y,fs,sig_name3]=signal_exc(LDF,'LDF',[1 600],400);

figure
subplot(211)
plot(t_x./60,x)
title('Noise part of LDF')
axis('tight')
xlabel('t[min]')
subplot(212)
plot(t_y./60,y)
title('Normal part of LDF')
axis('tight')
xlabel('t[min]')

figure
subplot(2,1,1)
fft_plot(x,fs,500*1024,'LDF noise')
subplot(2,1,2)
fft_plot(y,fs,500*1024,'LDF normal')


[x_w,t_w,fs1_w,lvl1]=wavedecom(x,t_x,fs,5,'db4');
[y_w,t_w,fs1_w,lvl1]=wavedecom(y,t_y,fs,5,'db4');
cwtX=cwtAnalysis(x_w,fs1_w,0.01,3);
cwtY=cwtAnalysis(y_w,fs1_w,0.01,3);
Mx=mean(abs(cwtX.cfs),2);
My=mean(abs(cwtY.cfs),2);



figure
subplot(2,1,1)
semilogx(cwtX.frequencies,abs(Mx))
title('CWT of LDF with noise')
xlabel('Hz')
subplot(2,1,2)
semilogx(cwtY.frequencies,abs(My))
title('CWT of LDF')
xlabel('Hz')


%% high pass filter
%plot(t(611*fs:625*fs),ECG(611*fs:625*fs))

%x=x-mean(x);

rp = 1;             % Passband ripple
rs = 6;             % Stopband ripple
f = [1.2 1.3];      % Cutoff frequencies
a = [0 1];          % Desired amplitudes

dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
[n,fo,ao,w] = firpmord(f,a,dev,fs);
b = firpm(n,fo,ao,w);
figure
freqz(b,1,1024,fs)

x_f=filter(b,1,x);
delay = mean(grpdelay(b));

t_x=t_x(1:end-delay);
x_f(1:delay)=[];


figure
subplot(2,1,1)
plot(t_x,x(1:end-delay))
subplot(2,1,2)
plot(t_x,x_f)

figure
subplot(2,1,1)
fft_plot(x,fs,100*1024,'LDF')
subplot(2,1,2)
fft_plot(x_f,fs,100*1024,'LDF filtered')

%% re inserting the filtered part

LDF(range(1)*fs:range(2)*fs-delay)=x_f;  %+mean(LDF(500*fs:600*fs));

figureb
plot(t(500*fs:min20*fs),LDF(500*fs:min20*fs))

[LDF_w,t1_w,fs1_w,lvl1]=wavedecom(LDF(500*fs:min20*fs),t(500*fs:min20*fs),fs,5,'db4');

cwt_3=cwtAnalysis(LDF_w,fs1_w,0.01,3);
cwt_plot1(cwt_3,t1_w,'LDF',9)


%% Adaptive treshold
[x2,i,xmedian,xsigma] = hampel(x,10000,3);

n = 1:length(x);
figure(1)
subplot(211)
plot(t_x./60,x)
hold on
plot(t_x./60,xmedian-3*xsigma,t_x./60,xmedian+3*xsigma)
plot(t_x(i)./60,x(i),'sk')
hold off
title('LDF, adaptive threshold')
xlabel('t[min]')
axis('tight')
legend('Original signal','Lower limit','Upper limit','Outliers')
subplot(212)
plot(t_x./60,x2)
title('LDF after removing outliers')
axis('tight')
xlabel('t[min]')

%% hard treshold
std_LDF=std(LDF(1:600*400));
median_LDF=median(LDF(1:600*400));
limit1=ones(1,length(x))*(median_LDF-4*std_LDF);
limit2=ones(1,length(x))*(median_LDF+4*std_LDF);
outliers=find(x>median_LDF+4*std_LDF);
outlierArray=zeros(1,length(x));
outlierArray(outliers)=1;
x3=x;
%x2(outliers)=median_LDF;
[x3,t_x] = replaceOutliers(t_x,x3, outlierArray,'median',500);

figure(2)
subplot(211)
plot(t_x./60,x), hold on
plot(t_x./60,limit1,t_x./60,limit2)
plot(t_x(outliers)./60,x(outliers),'sk')
hold off
axis('tight')
xlabel('t[min]')
title('LDF, hard threshold')
xlabel('t[min]')
subplot(212)
plot(t_x./60,x3)
title('LDF after removing outliers')
axis('tight')
xlabel('t[min]')


%%
[LDF_w,t3_w,fs3_w,lvl3]=wavedecom(x2,t_x,fs,5,'db4');
cwt_3=cwtAnalysis(LDF_w,fs3_w,0.01,3);

[y_w,t3_w,fs3_w,lvl3]=wavedecom(x3,t_x,fs,5,'db4');
cwt_4=cwtAnalysis(y_w,fs3_w,0.01,3);
% figure
% subplot(2,1,1)
% cwt_plot1(cwt_3,t3_w,'LDF adaptiv treshold')
% subplot(2,1,2)
% cwt_plot1(cwt_4,t3_w,'LDF hard treshold')

figure
subplot(3,1,1)
semilogx(cwtX.frequencies,mean(abs(cwtX.cfs),2));
axis('tight')
title('LDF with noise')
xlabel('Hz')
subplot(3,1,2)
semilogx(cwt_3.frequencies,mean(abs(cwt_3.cfs),2));
axis('tight')
title('LDF with adaptive threshold')
xlabel('Hz')
subplot(3,1,3)
semilogx(cwt_4.frequencies,mean(abs(cwt_4.cfs),2));
axis('tight')
title('LDF with hard threshold')
xlabel('Hz')

figure
subplot(3,1,1)
fft_plot(x,fs,100*1024,'LDF with noise')
subplot(3,1,2)
fft_plot(x2,fs,100*1024,'LDF with adaptive threshold')
subplot(3,1,3)
fft_plot(x3,fs,100*1024,'LDF with Hard threshold')
