%comparing GUI features
clear

load('D160317_t.mat');
load('D160329_t.mat');
load('D160331_t.mat');
load('D160406_t.mat');
load('D160407_t.mat');
load('D160413_t.mat');
load('D160421_t.mat');
load('D160510_t.mat');
load('D160512_t.mat');
load('D160524_t.mat');

signal_name={'HRV','BP','LDF'};
segments={'HR','Resp','Myo','Neuro','eMeta','VLF'};
events={' Pre',' Post1',' Post2',' Post3'};
patient_list={'160317','160329','160331','160406','160407','160413','160421','160510','160512','160524'};
Var_list={'P1','P2','P3','Peak_sig1','Peak_sig2','Peak_sig3','Peak_freq1','Peak_freq2','Peak_freq3'};

%Dele data i segmenter
for i=1:length(events)
    HR(i).data(:,:)=[table2array(D160317.HR(i,:)); table2array(D160329.HR(i,:)); table2array(D160331.HR(i,:)); table2array(D160406.HR(i,:));...
        table2array(D160407.HR(i,:)); table2array(D160413.HR(i,:)); table2array(D160421.HR(i,:)); table2array(D160510.HR(i,:)); table2array(D160512.HR(i,:)); table2array(D160524.HR(i,:)) ];
    HR(i).data(:,1)=NaN; HR(i).data(:,4)=NaN; HR(i).data(:,7)=NaN;
    HR(i).event_name=events(i);
    HR(i).data(HR(i).data==0)=NaN;
    HR(i).table=array2table(HR(i).data);
    %HR(i).table.Properties.RowNames=patient_list;
    HR(i).table.Properties.VariableNames=strcat(Var_list,'_HR');
    
    Resp(i).data(:,:)=[table2array(D160317.resp(i,:)); table2array(D160329.resp(i,:)); table2array(D160331.resp(i,:)); table2array(D160406.resp(i,:));...
        table2array(D160407.resp(i,:)); table2array(D160413.resp(i,:)); table2array(D160421.resp(i,:)); table2array(D160510.resp(i,:)); table2array(D160512.resp(i,:)); table2array(D160524.resp(i,:)) ];
    Resp(i).data(Resp(i).data==0)=NaN;
    Resp(i).event_name=events(i);
    Resp(i).table=array2table(Resp(i).data);
    %Resp(i).table.Properties.RowNames=patient_list;
    Resp(i).table.Properties.VariableNames=strcat(Var_list,'_Resp');
    
    myo(i).data(:,:)=[table2array(D160317.myo(i,:)); table2array(D160329.myo(i,:)); table2array(D160331.myo(i,:)); table2array(D160406.myo(i,:));...
        table2array(D160407.myo(i,:)); table2array(D160413.myo(i,:)); table2array(D160421.myo(i,:)); table2array(D160510.myo(i,:)); table2array(D160512.myo(i,:)); table2array(D160524.myo(i,:)) ];
    myo(i).data(myo(i).data==0)=NaN;
    myo(i).event_name=events(i);
    myo(i).table=array2table(myo(i).data);
    %myo(i).table.Properties.RowNames=patient_list;
    myo(i).table.Properties.VariableNames=strcat(Var_list,'_Myo');
    
    neuro(i).data(:,:)=[table2array(D160317.neuro(i,:)); table2array(D160329.neuro(i,:)); table2array(D160331.neuro(i,:)); table2array(D160406.neuro(i,:));...
        table2array(D160407.neuro(i,:)); table2array(D160413.neuro(i,:)); table2array(D160421.neuro(i,:)); table2array(D160510.neuro(i,:)); table2array(D160512.neuro(i,:)); table2array(D160524.neuro(i,:)) ];
    neuro(i).data(neuro(i).data==0)=NaN;
    neuro(i).event_name=events(i);
    neuro(i).table=array2table(neuro(i).data);
    %neuro(i).table.Properties.RowNames=patient_list;
    neuro(i).table.Properties.VariableNames=strcat(Var_list,'_neuro');
    
    eMeta(i).data(:,:)=[table2array(D160317.eMeta(i,:)); table2array(D160329.eMeta(i,:)); table2array(D160331.eMeta(i,:)); table2array(D160406.eMeta(i,:));...
        table2array(D160407.eMeta(i,:)); table2array(D160413.eMeta(i,:)); table2array(D160421.eMeta(i,:)); table2array(D160510.eMeta(i,:)); table2array(D160512.eMeta(i,:)); table2array(D160524.eMeta(i,:)) ];
    eMeta(i).data(eMeta(i).data==0)=NaN;
    eMeta(i).event_name=events(i);
    eMeta(i).table=array2table(eMeta(i).data);
    %eMeta(i).table.Properties.RowNames=patient_list;
    eMeta(i).table.Properties.VariableNames=strcat(Var_list,'_eMeta');
    
    VLF(i).data(:,:)=[table2array(D160317.VLF(i,:)); table2array(D160329.VLF(i,:)); table2array(D160331.VLF(i,:)); table2array(D160406.VLF(i,:));...
        table2array(D160407.VLF(i,:)); table2array(D160413.VLF(i,:)); table2array(D160421.VLF(i,:)); table2array(D160510.VLF(i,:)); table2array(D160512.VLF(i,:)); table2array(D160524.VLF(i,:)) ];
    VLF(i).data(VLF(i).data==0)=NaN;
    VLF(i).event_name=events(i);
    VLF(i).table=array2table(VLF(i).data);
    %VLF(i).table.Properties.RowNames=patient_list;
    VLF(i).table.Properties.VariableNames=strcat(Var_list,'_VLF');
    
end

%% Sorting data in one big table

HR_table=[];
Resp_table=[];
myo_table=[];
neuro_table=[];
eMeta_table=[];
VLF_table=[];

for i=1:4
    
    HR(i).data(:,10)=i;
    Resp(i).data(:,10)=i;
    myo(i).data(:,10)=i;
    neuro(i).data(:,10)=i;
    eMeta(i).data(:,10)=i;
    VLF(i).data(:,10)=i;
    
    
    HR_table=[HR_table; HR(i).table];
    Resp_table=[Resp_table; Resp(i).table];
    myo_table=[myo_table; myo(i).table];
    neuro_table=[neuro_table; neuro(i).table];
    eMeta_table=[eMeta_table; eMeta(i).table];
    VLF_table=[VLF_table; VLF(i).table];
    
end

TTT=[HR_table Resp_table myo_table neuro_table eMeta_table VLF_table];

data_HR=[HR(1).data; HR(2).data; HR(3).data; HR(4).data;];
data_resp=[Resp(1).data; Resp(2).data; Resp(3).data; Resp(4).data;];
data_myo=[myo(1).data; myo(2).data; myo(3).data; myo(4).data;];
data_neuro=[neuro(1).data; neuro(2).data; neuro(3).data; neuro(4).data;];
data_eMeta=[eMeta(1).data; eMeta(2).data; eMeta(3).data; eMeta(4).data;];
data_VLF=[VLF(1).data; VLF(2).data; VLF(3).data; VLF(4).data;];

%data_HR(:,1)=[];        %only NaN
%data_HR(:,4-1)=[];      %only NaN
%data_HR(:,7-2)=[];      %only NaN

%data_myo(:,5)=[];       %only NaN for class pre
%data_myo(:,7)=[];       %only NaN for class pre

DATA=[data_HR(:,1:9) data_resp(:,1:9) data_myo(:,1:9) data_neuro(:,1:9) data_eMeta(:,1:9) data_VLF(:,1:9)];
%Data_power=[data_HR(:,1:2), data_resp(:,1:3), data_myo(:,1:3), data_neuro(:,1:3), data_eMeta(:,1:3), data_VLF(:,1:3), data_VLF(:,10)];

segment_nr=data_HR(:,10);
seg_names(1:10)=events(1);
seg_names(11:20)=events(2);
seg_names(21:30)=events(3);
seg_names(31:40)=events(4);
segment_names=seg_names';
Patients=[patient_list'; patient_list'; patient_list'; patient_list'];

for i=1:10
    Patients_nr(i,1)=str2num(Patients{i});
end
Patients_nr=[Patients_nr; Patients_nr; Patients_nr; Patients_nr];
Master_table=table(Patients,Patients_nr,segment_names,segment_nr);
M_table=[Master_table TTT];
M_table.Patients=categorical(M_table.Patients);


%% fixed model
M_table.seg_center=M_table.segment_nr- mean(unique(M_table.segment_nr));

%lm= fitlm(M_table,'segment_nr ~ 1 + Peak_fre2_HR + Peak_freq2_resp')         %BP
%lm1= fitlm(M_table,'segment_nr ~ 1 + Peak_fre3_HR + Peak_freq3_resp')        %LDF


%% fixed model group
%lm_group=fitlm(M_table,'Peak_freq2_HR ~ 1 + seg_center + Patients + seg_center:Patients');


%% random model 

%lme2=fitlme(M_table,'Peak_freq2_HR ~ 1 + seg_center + (1+seg_center|Patients)')
%lme3=fitlme(M_table,'Peak_freq3_HR ~ 1 + seg_center + (1+seg_center|Patients)')

%% 
%results = compare(lm,lm1)



%% application learner 

APP_t=M_table(:,3:end-1);
APP_t.segment_nr=[];
APP_t.P1_HR=[];
APP_t.Peak_sig1_HR=[];
APP_t.Peak_freq1_HR=[];
APP_t.Peak_sig2_Myo=[];
APP_t.Peak_freq2_Myo=[];


