% compare features from GUI

[filename,filepath]=uigetfile({'*.*','All Files'},'Select Data File 1');
load([filepath filename]);

seg_name={'HR','Resp','Myo','Neuro','eMeta','VLF'};
events={' Pre',' Post1',' Post2',' Post3'};
P1_n=P1./sum(P1);
P2_n=P2./sum(P2);
P3_n=P3./sum(P3);

t1=table(P1_n,P2_n,P3_n,peak_sig1,peak_sig2,peak_sig3,peak_freq_sig1,peak_freq_sig2,peak_freq_sig3,'rownames',strcat(seg_name,events(1)));
D160524.pre=t1;

[filename,filepath]=uigetfile({'*.*','All Files'},'Select Data File 2');
load([filepath filename]);
P1_n=P1./sum(P1);
P2_n=P2./sum(P2);
P3_n=P3./sum(P3);

t2=table(P1_n,P2_n,P3_n,peak_sig1,peak_sig2,peak_sig3,peak_freq_sig1,peak_freq_sig2,peak_freq_sig3,'rownames',strcat(seg_name,events(2)));
D160524.post1=t2;

[filename,filepath]=uigetfile({'*.*','All Files'},'Select Data File 3');
load([filepath filename]);
P1_n=P1./sum(P1);
P2_n=P2./sum(P2);
P3_n=P3./sum(P3);

t3=table(P1_n,P2_n,P3_n,peak_sig1,peak_sig2,peak_sig3,peak_freq_sig1,peak_freq_sig2,peak_freq_sig3,'rownames',strcat(seg_name,events(3)));
D160524.post2=t3;



[filename,filepath]=uigetfile({'*.*','All Files'},'Select Data File 4');
load([filepath filename]);
P1_n=P1./sum(P1);
P2_n=P2./sum(P2);
P3_n=P3./sum(P3);

t4=table(P1_n,P2_n,P3_n,peak_sig1,peak_sig2,peak_sig3,peak_freq_sig1,peak_freq_sig2,peak_freq_sig3,'rownames',strcat(seg_name,events(4)));
D160524.post3=t4;

T_HR=[t1(1,:); t2(1,:); t3(1,:); t4(1,:)];
T_resp=[t1(2,:); t2(2,:); t3(2,:); t4(2,:)];
T_myo=[t1(3,:); t2(3,:); t3(3,:); t4(3,:)];
T_neur=[t1(4,:); t2(4,:); t3(4,:); t4(4,:)];
T_eMeta=[t1(5,:); t2(5,:); t3(5,:); t4(5,:)];
T_VLF=[t1(6,:); t2(6,:); t3(6,:); t4(6,:)];

D160524.HR=T_HR;
D160524.resp=T_resp;
D160524.myo=T_myo;
D160524.neuro=T_neur;
D160524.eMeta=T_eMeta;
D160524.VLF=T_VLF;

save('D160524_t.mat','D160524')

A=table2array(T_HR);

figure
for i=1:9
    subplot(3,3,i)
    stem(A(:,i))
    title([T_HR.Properties.VariableNames(i) ' HR'])
    set(gca, 'XTickLabelMode', 'Manual')
    set(gca, 'XTick', [])
    set(gca,'XTickLabel',events)
    set(gca, 'Box','off')
end
