%% comparing features from diffren events
%% prossesing
load('Test_20160204.mat')
%prosesing
for n=1:1
%First part
ECG=data(1:dataend(1,1));
HR=data(datastart(2,1):dataend(2,1));
BP=data(datastart(3,1):dataend(3,1));
sys=data(datastart(4,1):dataend(4,1));
LDF=data(datastart(5,1):dataend(5,1));
resp=data(datastart(6,1):dataend(6,1));

%second part, pga restart or somthing of the program
ECG_2=data(datastart(1,2):dataend(1,2));
HR_2=data(datastart(2,2):dataend(2,2));
BP_2=data(datastart(3,2):dataend(3,2));
sys_2=data(datastart(4,2):dataend(4,2));
LDF_2=data(datastart(5,2):dataend(5,2));
resp_2=data(datastart(6,2):dataend(6,2));

% full signal
ECG=[ECG ECG_2];    
HR=[HR HR_2];
BP=[BP BP_2];
sys=[sys sys_2];
LDF=[LDF LDF_2];
resp=[resp resp_2];

fs=samplerate(1,1);
L=length(ECG);
t=0:1/fs:L/fs-1/fs;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60; min60=60*60;

range=[1 min50];        % [1-5064] sec


%removing artifacts
%ECG 
art_rem='filter';      % could be either, 'detrend' or 'filter'
for n=1:1
    if strcmp(art_rem,'filter')
        x=ECG(611*fs:625*fs);
        t_x=t(611*fs:625*fs);

        x=x-mean(x);

        rp = 1;             % Passband ripple
        rs = 6;             % Stopband ripple
        f = [0.5 0.7];      % Cutoff frequencies
        a = [0 1];          % Desired amplitudes

        dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
        [m,fo,ao,w] = firpmord(f,a,dev,fs);
        b = firpm(m,fo,ao,w);
        x_f=filter(b,1,x);
        delay = mean(grpdelay(b));
        t_x=t_x(1:end-delay);
        x_f(1:delay)=[];
        ECG(611*fs:625*fs-delay)=x_f+mean(ECG(500*fs:600*fs));
    end
    
    if strcmp(art_rem,'trend')
        opol = 10;
        [p,s,mu] = polyfit(t(612*fs:616*fs),ECG(612*fs:616*fs),opol);
        f_y = polyval(p,t(612*fs:616*fs),[],mu);
        ECG(612*fs:616*fs) = ECG(612*fs:616*fs) - f_y + mean(f_y);
        ECG(612*fs:616*fs)=detrend(ECG(612*fs:616*fs))+median(ECG);

        opol = 10;
        [p,s,mu] = polyfit(t(621*fs:623*fs),ECG(621*fs:623*fs),opol);
        f_y = polyval(p,t(621*fs:623*fs),[],mu);
        ECG(621*fs:623*fs) = ECG(621*fs:623*fs) - f_y + mean(f_y);
        ECG(621*fs:623*fs)=detrend(ECG(621*fs:623*fs))+median(ECG);
        ECG(616*fs:621*fs)=detrend(ECG(616*fs:621*fs))+median(ECG);
        ECG(621.1*fs:627*fs)=detrend(ECG(621.1*fs:627*fs))+median(ECG);
    end
end
%LDF
for n=1:1
std_LDF=std(LDF(1:600*400));
median_LDF=median(LDF(1:600*400));
limit1=ones(1,length(LDF))*(median_LDF-4*std_LDF);
limit2=ones(1,length(LDF))*(median_LDF+4*std_LDF);
outliers=find(LDF>median_LDF+3*std_LDF);
outlierArray=zeros(1,length(LDF));
outlierArray(outliers)=1;
%x2(outliers)=median_LDF;
[LDF,t] = replaceOutliers(t,LDF, outlierArray,'median',1000);
end


end


%% 0-10min
%events
range1=[1 min10 min20 min30 min40 min50 min60];
for n=1:length(range1)-1
    ECG1 =ECG((range1(n)*fs)+1:range1(n+1)*fs);
    BP1  =BP((range1(n)*fs)+1:range1(n+1)*fs);
    %HRV
    hrv=findHRV(ECG1,fs);
    hrv_mean(n,1)=mean(hrv);
    hrv_std(n,1)=std(hrv);
    %Systolic BP
    [sys1,locs_sys]=findpeaks(BP1,'MinPeakHeight',110,'MinPeakDistance',200);
    sys_mean(n,1)=mean(sys1);
    sys_std(n,1)=std(sys1);
    %Diastolic BP
    [dia1,locs_dia]=findpeaks(-1*BP1,'MinPeakHeight',-80,'MinPeakDistance',200);
    dia_mean(n,1)=mean(abs(dia1));
    dia_std(n,1)=std(abs(dia1));

end

times={'Baseline','Tilting bed up','Tilting bed down','30-40min','40-50min','50-60min'};
T=table(hrv_mean,hrv_std,sys_mean,sys_std,dia_mean,dia_std,'RowNames',times);
