%% comapring time evetnes in frequency domain
load('Test_20160204.mat')

ECG=[]; HR=[]; BP=[]; sys=[]; LDF=[];  resp=[];

for i=1:size(dataend,2)
ECG=    [ECG data(datastart(1,i):dataend(1,i))];
HR=     [HR data(datastart(2,i):dataend(2,i))];
BP=     [BP data(datastart(3,1):dataend(3,1))];
LDF=    [LDF data(datastart(5,i):dataend(5,i))];
resp=   [resp data(datastart(6,1):dataend(6,1))];
end

fs=samplerate(1,1);
L=length(ECG);
t=0:1/fs:L/fs-1/fs;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;
min60=60*60;
range=[1 min50];        % [1-5064] sec


%removing artifacts
%ECG 
art_rem='filter';      % could be either, 'detrend' or 'filter'
for n=1:1
    if strcmp(art_rem,'filter')
        x=ECG(611*fs:625*fs);
        t_x=t(611*fs:625*fs);

        x=x-mean(x);

        rp = 1;             % Passband ripple
        rs = 6;             % Stopband ripple
        f = [0.5 0.7];      % Cutoff frequencies
        a = [0 1];          % Desired amplitudes

        dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
        [m,fo,ao,w] = firpmord(f,a,dev,fs);
        b = firpm(m,fo,ao,w);
        x_f=filter(b,1,x);
        delay = mean(grpdelay(b));
        t_x=t_x(1:end-delay);
        x_f(1:delay)=[];
        ECG(611*fs:625*fs-delay)=x_f+mean(ECG(500*fs:600*fs));
    end
    
    if strcmp(art_rem,'trend')
        opol = 10;
        [p,s,mu] = polyfit(t(612*fs:616*fs),ECG(612*fs:616*fs),opol);
        f_y = polyval(p,t(612*fs:616*fs),[],mu);
        ECG(612*fs:616*fs) = ECG(612*fs:616*fs) - f_y + mean(f_y);
        ECG(612*fs:616*fs)=detrend(ECG(612*fs:616*fs))+median(ECG);

        opol = 10;
        [p,s,mu] = polyfit(t(621*fs:623*fs),ECG(621*fs:623*fs),opol);
        f_y = polyval(p,t(621*fs:623*fs),[],mu);
        ECG(621*fs:623*fs) = ECG(621*fs:623*fs) - f_y + mean(f_y);
        ECG(621*fs:623*fs)=detrend(ECG(621*fs:623*fs))+median(ECG);
        ECG(616*fs:621*fs)=detrend(ECG(616*fs:621*fs))+median(ECG);
        ECG(621.1*fs:627*fs)=detrend(ECG(621.1*fs:627*fs))+median(ECG);
    end
end
%LDF
for n=1:1
std_LDF=std(LDF(1:600*400));
median_LDF=median(LDF(1:600*400));
limit1=ones(1,length(LDF))*(median_LDF-4*std_LDF);
limit2=ones(1,length(LDF))*(median_LDF+4*std_LDF);
outliers=find(LDF>median_LDF+3*std_LDF);
outlierArray=zeros(1,length(LDF));
outlierArray(outliers)=1;
%x2(outliers)=median_LDF;
[LDF,t] = replaceOutliers(t,LDF, outlierArray,'median',1000);
end

for n=1:1
[ECG_base,t1,fs,sig_name1]=signal_exc(ECG,'ECG',range,fs);
[BP_base,t2,fs,sig_name2]=signal_exc(BP,'BP',range,fs);
[LDF_base,t3,fs,sig_name3]=signal_exc(LDF,'LDF',range,fs);
[resp_base,t4,fs,sig_name4]=signal_exc(resp,'resp',range,fs);

[ECG_w,t1_w,fs1_w,lvl1]=wavedecom(ECG_base,t1,fs,5,'db4');
[BP_w,t2_w,fs2_w,lvl2]=wavedecom(BP_base,t2,fs,5,'db4');
[LDF_w,t3_w,fs3_w,lvl3]=wavedecom(LDF_base,t3,fs,5,'db4');
[resp_w,t4_w,fs4_w,lvl4]=wavedecom(resp_base,t4,fs,5,'db4');

ECG_w_mean=mean(ECG_w);
ECG_w=ECG_w-ECG_w_mean;

BP_w_mean=mean(BP_w);
BP_w=BP_w-BP_w_mean;

LDF_w_mean=mean(LDF_w);
LDF_w=LDF_w-LDF_w_mean;

resp_w_mean=mean(resp_w);
resp_w=resp_w-resp_w_mean;
end
%%
range1=[0 min10 min20 min30 min40 min50];
%range1=[0 5*60 min10 15*60 min20 25*60];

for n=1:3
    ECG1 =ECG_w((range1(n)*fs1_w)+1:range1(n+1)*fs1_w);
    BP1  =BP_w((range1(n)*fs1_w)+1:range1(n+1)*fs1_w);
    LDF1  =LDF_w((range1(n)*fs1_w)+1:range1(n+1)*fs1_w);
    resp1  =resp_w((range1(n)*fs1_w)+1:range1(n+1)*fs1_w);
tic
cwt_1=cwtAnalysis(ECG1,fs1_w,0.01,3);

cwt_2=cwtAnalysis(BP1,fs2_w,0.01,3);

cwt_3=cwtAnalysis(LDF1,fs3_w,0.01,3);

cwt_4=cwtAnalysis(resp1,fs4_w,0.01,3);
toc


M1(n,:)=mean(abs(cwt_1.cfs),2);  %ECG
M2(n,:)=mean(abs(cwt_2.cfs),2);  %BP
M3(n,:)=mean(abs(cwt_3.cfs),2);  %LDF
M4(n,:)=mean(abs(cwt_4.cfs),2);  %Resp


end
f1=[0.6 1.6];       %Heart rate activity
f2=[0.1 0.4];       %Respiratory activity
f3=[0.06 0.1];      %Myogenic activity
f4=[0.02 0.06];     %neurogenic activity
f5=[0.009 0.02];    %meatbolic activity

pos_f1=find((cwt_1.frequencies>=f1(1)) & (cwt_1.frequencies<=f1(2)));
pos_f2=find((cwt_1.frequencies>=f2(1)) & (cwt_1.frequencies<=f2(2)));
pos_f3=find((cwt_1.frequencies>=f3(1)) & (cwt_1.frequencies<=f3(2)));
pos_f4=find((cwt_1.frequencies>=f4(1)) & (cwt_1.frequencies<=f4(2)));
pos_f5=find((cwt_1.frequencies>=f5(1)) & (cwt_1.frequencies<=f5(2)));


figure(1)
subplot(3,1,1)
semilogx(cwt_1.frequencies,abs(M1))
title('Frequency respons for ECG')
axis('tight')
legend('0-10','10-20','20-30')
hold on
xlim=[min(min(abs(M1))) max(max(abs(M1)))];
plot([f1(1) f1(1)],[xlim(1) xlim(2)],'r--')
plot([f1(2) f1(2)],[xlim(1) xlim(2)],'r--')
plot([f2(1) f2(1)],[xlim(1) xlim(2)],'r--')
plot([f2(2) f2(2)],[xlim(1) xlim(2)],'r--')
plot([f3(1) f3(1)],[xlim(1) xlim(2)],'r--')
plot([f3(2) f3(2)],[xlim(1) xlim(2)],'r--')
plot([f4(1) f4(1)],[xlim(1) xlim(2)],'r--')
plot([f4(2) f4(2)],[xlim(1) xlim(2)],'r--')
plot([f5(1) f5(1)],[xlim(1) xlim(2)],'r--')
plot([f5(2) f5(2)],[xlim(1) xlim(2)],'r--')
hold off


subplot(3,1,2)
semilogx(cwt_1.frequencies,abs(M2))
title('Frequency respons for BP')
axis('tight')
legend('0-10','10-20','20-30')
hold on
xlim=[min(min(abs(M2))) max(max(abs(M2)))];
plot([f1(1) f1(1)],[xlim(1) xlim(2)],'r--')
plot([f1(2) f1(2)],[xlim(1) xlim(2)],'r--')
plot([f2(1) f2(1)],[xlim(1) xlim(2)],'r--')
plot([f2(2) f2(2)],[xlim(1) xlim(2)],'r--')
plot([f3(1) f3(1)],[xlim(1) xlim(2)],'r--')
plot([f3(2) f3(2)],[xlim(1) xlim(2)],'r--')
plot([f4(1) f4(1)],[xlim(1) xlim(2)],'r--')
plot([f4(2) f4(2)],[xlim(1) xlim(2)],'r--')
plot([f5(1) f5(1)],[xlim(1) xlim(2)],'r--')
plot([f5(2) f5(2)],[xlim(1) xlim(2)],'r--')
hold off



subplot(3,1,3)
semilogx(cwt_1.frequencies,abs(M3))
title('Frequency respons for LDF')
axis('tight')
legend('0-10','10-20','20-30')
hold on
xlim=[min(min(abs(M3))) max(max(abs(M3)))];
plot([f1(1) f1(1)],[xlim(1) xlim(2)],'r--')
plot([f1(2) f1(2)],[xlim(1) xlim(2)],'r--')
plot([f2(1) f2(1)],[xlim(1) xlim(2)],'r--')
plot([f2(2) f2(2)],[xlim(1) xlim(2)],'r--')
plot([f3(1) f3(1)],[xlim(1) xlim(2)],'r--')
plot([f3(2) f3(2)],[xlim(1) xlim(2)],'r--')
plot([f4(1) f4(1)],[xlim(1) xlim(2)],'r--')
plot([f4(2) f4(2)],[xlim(1) xlim(2)],'r--')
plot([f5(1) f5(1)],[xlim(1) xlim(2)],'r--')
plot([f5(2) f5(2)],[xlim(1) xlim(2)],'r--')
hold off

