load('Test_20160204.mat')

ECG=[]; HR=[]; BP=[]; sys=[]; LDF=[];  resp=[];

for i=1:size(dataend,2)
ECG=    [ECG data(datastart(1,i):dataend(1,i))];
HR=     [HR data(datastart(2,i):dataend(2,i))];
BP=     [BP data(datastart(3,1):dataend(3,1))];
LDF=    [LDF data(datastart(5,i):dataend(5,i))];
resp=   [resp data(datastart(6,1):dataend(6,1))];
end

fs=samplerate(1,1);
L=length(ECG);
t=0:1/fs:L/fs-1/fs;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;

range1=[1 min10];        % [1-5064] sec
range2=[min10 min20];
range3=[min20 min30];
range4=[min30 min40];

%%

[BP1,t1,fs,sig_name2]=signal_exc(BP,'BP',range1,fs);
[BP2,t2,fs,sig_name2]=signal_exc(BP,'BP',range2,fs);
[BP3,t3,fs,sig_name2]=signal_exc(BP,'BP',range3,fs);
[BP4,t4,fs,sig_name2]=signal_exc(BP,'BP',range4,fs);
[LDF1,t1,fs,sig_name3]=signal_exc(LDF,'LDF',range1,fs);


[BP_w1,t1_w,fs2_w,lvl2]=wavedecom(BP1,t1,fs,1,'db4');
[BP_w2,t2_w,fs2_w,lvl2]=wavedecom(BP2,t2,fs,1,'db4');
[BP_w3,t3_w,fs2_w,lvl2]=wavedecom(BP3,t3,fs,1,'db4');
[BP_w4,t4_w,fs2_w,lvl2]=wavedecom(BP4,t4,fs,1,'db4');
[LDF_w1,t1_w,fs3_w,lvl3]=wavedecom(LDF1,t3,fs,5,'db4');




%% wavlet analysis
tic
cwt_1=cwtAnalysis(BP_w1,fs2_w,0.01,2);

cwt_2=cwtAnalysis(BP_w2,fs2_w,0.01,2);

cwt_3=cwtAnalysis(BP_w3,fs2_w,0.01,2);

cwt_4=cwtAnalysis(BP_w4,fs2_w,0.01,2);

toc

%% freq stat
M1=mean(abs(cwt_1.cfs),2);  %
M2=mean(abs(cwt_2.cfs),2);  %
M3=mean(abs(cwt_3.cfs),2);  %
M4=mean(abs(cwt_4.cfs),2);  %


figure(1)
semilogx(cwt_1.frequencies,abs(M1))
hold on
semilogx(cwt_1.frequencies,abs(M2))
semilogx(cwt_1.frequencies,abs(M3))
semilogx(cwt_1.frequencies,abs(M4))
hold off
legend('BP(0:10)','BP(10:20)','BP(20:30)','BP(30:40)')

%% Difference to first segment
diff11=diff([abs(M1');abs(M1)'],1,1);
diff12=diff([abs(M1)';abs(M2)'],1,1);
diff13=diff([abs(M1)';abs(M3)'],1,1);
diff14=diff([abs(M1)';abs(M4)'],1,1);

figure(2)
semilogx(cwt_1.frequencies,abs(diff11))
hold on
semilogx(cwt_1.frequencies,diff12)
semilogx(cwt_1.frequencies,diff13)
semilogx(cwt_1.frequencies,diff14)
hold off
legend('BP(0:10)','BP(10:20)','BP(20:30)','BP(30:40)')



