%% test4 
load('Test_20160204.mat')

ECG=[]; HR=[]; BP=[]; sys=[]; LDF=[];  resp=[];

for i=1:size(dataend,2)
ECG=    [ECG data(datastart(1,i):dataend(1,i))];
HR=     [HR data(datastart(2,i):dataend(2,i))];
BP=     [BP data(datastart(3,1):dataend(3,1))];
LDF=    [LDF data(datastart(5,i):dataend(5,i))];
resp=   [resp data(datastart(6,1):dataend(6,1))];
end

fs=samplerate(1,1);
L=length(ECG);
t=0:1/fs:L/fs-1/fs;
t=t./60;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;

range=[1 min50];        % [1-5064] sec


%removing artifacts
ECG ;
art_rem='filter';      % could be either, 'detrend' or 'filter'
for n=1:1
    if strcmp(art_rem,'filter')
        x=ECG(611*fs:625*fs);
        t_x=t(611*fs:625*fs);

        x=x-mean(x);

        rp = 1;             % Passband ripple
        rs = 6;             % Stopband ripple
        f = [0.5 0.7];      % Cutoff frequencies
        a = [0 1];          % Desired amplitudes

        dev = [(10^(rp/20)-1)/(10^(rp/20)+1)  10^(-rs/20)];
        [m,fo,ao,w] = firpmord(f,a,dev,fs);
        b = firpm(m,fo,ao,w);
        x_f=filter(b,1,x);
        delay = mean(grpdelay(b));
        t_x=t_x(1:end-delay);
        x_f(1:delay)=[];
        ECG(611*fs:625*fs-delay)=x_f+mean(ECG(500*fs:600*fs));
    end
    
    if strcmp(art_rem,'trend')
        opol = 10;
        [p,s,mu] = polyfit(t(612*fs:616*fs),ECG(612*fs:616*fs),opol);
        f_y = polyval(p,t(612*fs:616*fs),[],mu);
        ECG(612*fs:616*fs) = ECG(612*fs:616*fs) - f_y + mean(f_y);
        ECG(612*fs:616*fs)=detrend(ECG(612*fs:616*fs))+median(ECG);

        opol = 10;
        [p,s,mu] = polyfit(t(621*fs:623*fs),ECG(621*fs:623*fs),opol);
        f_y = polyval(p,t(621*fs:623*fs),[],mu);
        ECG(621*fs:623*fs) = ECG(621*fs:623*fs) - f_y + mean(f_y);
        ECG(621*fs:623*fs)=detrend(ECG(621*fs:623*fs))+median(ECG);
        ECG(616*fs:621*fs)=detrend(ECG(616*fs:621*fs))+median(ECG);
        ECG(621.1*fs:627*fs)=detrend(ECG(621.1*fs:627*fs))+median(ECG);
    end
end
%LDF
for n=1:1
std_LDF=std(LDF(1:600*400));
median_LDF=median(LDF(1:600*400));
limit1=ones(1,length(LDF))*(median_LDF-4*std_LDF);
limit2=ones(1,length(LDF))*(median_LDF+4*std_LDF);
outliers=find(LDF>median_LDF+3*std_LDF);
outlierArray=zeros(1,length(LDF));
outlierArray(outliers)=1;
%x2(outliers)=median_LDF;
[LDF,t] = replaceOutliers(t,LDF, outlierArray,'median',1000);
end

for n=1:1
[ECG_base,t1,fs,sig_name1]=signal_exc(ECG,'ECG',range,fs);
[BP_base,t2,fs,sig_name2]=signal_exc(BP,'BP',range,fs);
[LDF_base,t3,fs,sig_name3]=signal_exc(LDF,'LDF',range,fs);
[resp_base,t4,fs,sig_name4]=signal_exc(resp,'resp',range,fs);

[ECG_w,t1_w,fs1_w,lvl1]=wavedecom(ECG_base,t1,fs,1,'db4');
[BP_w,t2_w,fs2_w,lvl2]=wavedecom(BP_base,t2,fs,1,'db4');
[LDF_w,t3_w,fs3_w,lvl3]=wavedecom(LDF_base,t3,fs,5,'db4');
[resp_w,t4_w,fs4_w,lvl4]=wavedecom(resp_base,t4,fs,5,'db4');

ECG_w_mean=mean(ECG_w);
ECG_w=ECG_w-ECG_w_mean;

BP_w_mean=mean(BP_w);
%BP_w=BP_w-BP_w_mean;

LDF_w_mean=mean(LDF_w);
LDF_w=LDF_w-LDF_w_mean;

resp_w_mean=mean(resp_w);
resp_w=resp_w-resp_w_mean;
end

%% Find R peaks and HRV

for n=1:1
[~,locs_R]=findHRV(ECG_base,fs,200);

figure(1)
hold on
plot(t1,ECG_base), grid
plot(t1(locs_R),ECG_base(locs_R),'rv','MarkerFaceColor','r');
axis('tight')
hold off
xlabel('Time [min]')
title('ECG with R peak detection')

for i=1:length(locs_R)-1
    RR(i)=(locs_R(i+1)-locs_R(i));
end

figure(2)
plot(t1(locs_R(1:end-1)),1./(RR./fs)), grid, hold on;
if range(1)<min10 && range(2)>min10; plot([min10 min10],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min20 && range(2)>min20; plot([min20 min20],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min30 && range(2)>min30; plot([min30 min30],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
if range(1)<min40 && range(2)>min40; plot([min40 min40],[min(1./(RR./fs)) max(abs(1./(RR./fs)))],'r--'); end
title('HRV')
xlabel('Time [min]')
ylabel('Hz')
axis('tight')
hold off

figure
hist((RR./fs)), grid
xlabel('Sampling interval [sec]')
ylabel('RR distribution')
end
figure
scatter(RR(2:end)./fs,RR(1:end-1)./fs);
xlabel('RR_n [sec]')
ylabel('RR_{n+1} [sec]')



%% Diastolic and stystolic BP extraction
for n=1:1
[sys1,locs_sys]=findpeaks(BP_base,'MinPeakHeight',110,'MinPeakDistance',200);

figure(3)
hold on
plot(t2,BP_base), grid
plot(t2(locs_sys),BP_base(locs_sys),'rv','MarkerFaceColor','r');
if range(1)<min10 && range(2)>min10; plot([min10 min10],[min(BP_base) max(abs(BP_base))],'r--'); end
if range(1)<min20 && range(2)>min20; plot([min20 min20],[min(BP_base) max(abs(BP_base))],'r--'); end
if range(1)<min30 && range(2)>min30; plot([min30 min30],[min(BP_base) max(abs(BP_base))],'r--'); end
if range(1)<min40 && range(2)>min40; plot([min40 min40],[min(BP_base) max(abs(BP_base))],'r--'); end
axis('tight')
hold off
xlabel('Time [sec]')
title('BP with systolic preasure detection')

figure(4)
plot(t2(locs_sys),sys1), hold on;
if range(1)<min10 && range(2)>min10; plot([min10 min10],[min(sys1) max(abs(sys1))],'r--'); end
if range(1)<min20 && range(2)>min20; plot([min20 min20],[min(sys1) max(abs(sys1))],'r--'); end
if range(1)<min30 && range(2)>min30; plot([min30 min30],[min(sys1) max(abs(sys1))],'r--'); end
if range(1)<min40 && range(2)>min40; plot([min40 min40],[min(sys1) max(abs(sys1))],'r--'); end
title('Systolic blood presure')
xlabel('Time [sec]')
axis('tight')
hold off

end

%% plot wavelet decomposition

figure(5)
wavedec_plot(ECG_base,t1,'ECG',ECG_w,t1_w,lvl1,range)

figure(6)
wavedec_plot(LDF_base,t3,'LDF',LDF_w,t3_w,lvl3,range)


%% fft
nfft1=50*1024;
figure(7)
fft_plot(ECG_w,fs1_w,nfft1,'ECG')

figure(8)
fft_plot(BP_w,fs2_w,nfft1,'BP')

figure(9)
fft_plot(LDF_w,fs3_w,nfft1,'LDF')

figure(10)
fft_plot(resp_w,fs4_w,nfft1,'resp')

x=BP_w;
xName='BP';

figure(11)
subplot(4,1,1)
fft_plot(x(1:min10*fs1_w),fs1_w,nfft1,[xName ' from 0-10min'])
subplot(4,1,2)
fft_plot(x((min10*fs1_w)+1:min20*fs1_w),fs1_w,nfft1,[xName ' from 10-20min'])
subplot(4,1,3)
fft_plot(x((min20*fs1_w)+1:min30*fs1_w),fs1_w,nfft1,[xName ' from 20-30min'])
subplot(4,1,4)
fft_plot(x((min30*fs1_w)+1:min40*fs1_w),fs1_w,nfft1,[xName ' from 30-40min'])



%% Spectrogram
Nx = length(ECG_w); 
nsc = floor(Nx/10);
nov = floor(nsc/2);
nff = 50*1024;  %max(1024,2^nextpow2(nsc));

SNR=130;
figure(12)
spectrogram(ECG_w,hamming(nsc),nov,nff,fs1_w,'yaxis');
set(gca,'Yscale','log')
view(-105,40)

%% wavlet analysis
tic
cwt_1=cwtAnalysis(ECG_w,fs1_w,0.01,2);

cwt_2=cwtAnalysis(BP_w,fs2_w,0.01,2);

cwt_3=cwtAnalysis(LDF_w,fs3_w,0.01,2);

cwt_4=cwtAnalysis(resp_w,fs4_w,0.01,2);


%cwt_plot(cwt_1,t1_w,sig_name1,cwt_2,t2_w,sig_name2...
%    ,cwt_3,t3_w,sig_name3,cwt_4,t4_w,sig_name4,13,14)
toc

%% freq stat
M1=mean(abs(cwt_1.cfs),2);  %ECG
M2=mean(abs(cwt_2.cfs),2);  %BP
M3=mean(abs(cwt_3.cfs),2);  %LDF
M4=mean(abs(cwt_4.cfs),2);  %Resp

figure(1)
subplot(4,1,1)
semilogx(cwt_1.frequencies,abs(M1))
title('Frequency respons for ECG')
axis('tight')
subplot(4,1,2)
semilogx(cwt_1.frequencies,abs(M2))
title('Frequency respons for BP')
axis('tight')
subplot(4,1,3)
semilogx(cwt_1.frequencies,abs(M3))
title('Frequency respons for LDF')
axis('tight')
subplot(4,1,4)
semilogx(cwt_1.frequencies,abs(M4))
title('Frequency respons for resp')
axis('tight')

%%

f1=[0.6 1.6];       %Heart rate activity
f2=[0.1 0.4];       %Respiratory activity
f3=[0.06 0.1];      %Myogenic activity
f4=[0.02 0.06];     %neurogenic activity
f5=[0.009 0.02];    %meatbolic activity

pos_f1=find((cwt_1.frequencies>=f1(1)) & (cwt_1.frequencies<=f1(2)));
pos_f2=find((cwt_1.frequencies>=f2(1)) & (cwt_1.frequencies<=f2(2)));
pos_f3=find((cwt_1.frequencies>=f3(1)) & (cwt_1.frequencies<=f3(2)));
pos_f4=find((cwt_1.frequencies>=f4(1)) & (cwt_1.frequencies<=f4(2)));
pos_f5=find((cwt_1.frequencies>=f5(1)) & (cwt_1.frequencies<=f5(2)));


%finding mean frequency and standard deviation
n=sum(M1(pos_f1));
mean1_f1=cwt_1.frequencies(pos_f1)*M1(pos_f1)/n;
std1_f1=(cwt_1.frequencies(pos_f1).^2*M1(pos_f1)-n*mean1_f1^2)/n;
powf1=sum(M1(pos_f1).^2);

n=sum(M2(pos_f1));
mean2_f1=cwt_1.frequencies(pos_f1)*M2(pos_f1)/n;
std2_f1=(cwt_1.frequencies(pos_f1).^2*M2(pos_f1)-n*mean2_f1^2)/n;
powf2=sum(M2(pos_f1).^2);

n=sum(M3(pos_f1));
mean3_f1=cwt_1.frequencies(pos_f1)*M3(pos_f1)/n;
std3_f1=(cwt_1.frequencies(pos_f1).^2*M3(pos_f1)-n*mean3_f1^2)/n;
powf3=sum(M3(pos_f1).^2);


figure(1)
semilogx(cwt_1.frequencies,abs(M1))
title('Frequency respons for ECG')
axis('tight')
hold on
plot([f1(1) f1(1)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f1(2) f1(2)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f2(1) f2(1)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f2(2) f2(2)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f3(1) f3(1)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f3(2) f3(2)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f4(1) f4(1)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f4(2) f4(2)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f5(1) f5(1)],[min(abs(M1)) max(abs(M1))],'r--')
plot([f5(2) f5(2)],[min(abs(M1)) max(abs(M1))],'r--')
hold off

figure(2)
semilogx(cwt_1.frequencies,abs(M3))
title('Frequency respons for LDF')
axis('tight')
hold on
plot([f1(1) f1(1)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f1(2) f1(2)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f2(1) f2(1)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f2(2) f2(2)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f3(1) f3(1)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f3(2) f3(2)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f4(1) f4(1)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f4(2) f4(2)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f5(1) f5(1)],[min(abs(M3)) max(abs(M3))],'r--')
plot([f5(2) f5(2)],[min(abs(M3)) max(abs(M3))],'r--')
hold off

figure(3)
semilogx(cwt_1.frequencies,abs(M2))
title('Frequency respons for BP')
axis('tight')
hold on
plot([f1(1) f1(1)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f1(2) f1(2)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f2(1) f2(1)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f2(2) f2(2)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f3(1) f3(1)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f3(2) f3(2)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f4(1) f4(1)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f4(2) f4(2)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f5(1) f5(1)],[min(abs(M2)) max(abs(M2))],'r--')
plot([f5(2) f5(2)],[min(abs(M2)) max(abs(M2))],'r--')
hold off

