%% Test feature extraction

fs=1000;

t1=0:1/fs:5-1/fs;
t2=5:1/fs:10-1/fs;
t=[t1 t2];

x1 =5*cos(2*pi*75*t1)+ cos(2*pi*100*t1)+10*cos(2*pi*50*t1);%+randn(size(t));
x2 =20*cos(2*pi*10*t2); 
x=[x2 x1];
L=length(x);

%% PSD welch
[pxx,f] = pwelch(x,1024,512,1024,fs);
figure(1)
plot(f,10*log10(pxx))

xlabel('Frequency (Hz)')
ylabel('Magnitude (dB)')

%% PSD fft
nfft=4*1024;
X=fft(x,nfft);
P2 = abs(X/nfft);
P1 = P2(1:nfft/2+1);
p = unwrap(angle(X(1:nfft/2+1)));
f = fs*(0:(nfft/2))/nfft;

figure(2)
subplot(211)
plot(f,20*log10(P1))
subplot(212)
plot(f,p)

%% Spectrogram
Nx = length(x);
nsc = floor(Nx/5);
nov = floor(nsc/2);
nff = 8*1024;     %max(1024,2^nextpow2(nsc));

figure(3)
spectrogram(x,hamming(nsc),nov,nff,fs);

%% Wavlet

