%% test5 
load('160317_01post.mat')

ECG=[]; BP=[]; LDF=[]; 
for i=5:size(dataend,2) %discarding first samples because BP missing
ECG=    [ECG data(datastart(1,i):dataend(1,i))];
if i>=5; BP=[BP data(datastart(2,i):dataend(2,i))]; end;
LDF=    [LDF data(datastart(3,i):dataend(3,i))];
end
clear data
fs=samplerate(1,1);
%discarding the first 2 minutes bc noise
ECG(1:2*60*fs)=[];
BP(1:2*60*fs)=[];
LDF(1:2*60*fs)=[];

L=length(ECG);
t=0:1/fs:L/fs-1/fs;
t_min=t./60;

nfft=200*1024;

range1=[1 60];
LDF1=LDF(range1(1)*60*fs:range1(2)*60*fs);
t1=t_min(range1(1)*60*fs:range1(2)*60*fs);
%%
LDF1_old=LDF1;
LDF1=LDF1-mean(LDF1);
LDF1(find(abs(LDF1)>3*std(LDF1)+mean(LDF1)))=mean(LDF1);
[LDF1_w,t1_w,fs_w,lvl3]=wavedecom(LDF1,t1,fs,5,'db4');
figure(1)
subplot(2,1,1)
plot(t1,LDF1_old), title('Old')
subplot(2,1,2)
plot(t1,LDF1), title('New')

%% CWT
cwt1=cwtAnalysis(LDF1_w,fs_w,0.0095,2);
M1=mean(abs(cwt1.cfs),2);

% hr_freq_stop=find(cwt1.frequencies<=0.6);
% resp_freq_stop=find(cwt1.frequencies<=0.145);
% myo_freq_stop=find(cwt1.frequencies<=0.052);
% neur_freq_stop=find(cwt1.frequencies<=0.021);
% 
% hr_freq=cwt1.frequencies(1:hr_freq_stop(1));
% resp_freq=cwt1.frequencies(hr_freq_stop(1):resp_freq_stop(1));
% myo_freq=cwt1.frequencies(resp_freq_stop(1):myo_freq_stop(1));
% neur_freq=cwt1.frequencies(myo_freq_stop(1):neur_freq_stop(1));
% eMeta_freq=cwt1.frequencies(neur_freq_stop(1):end);
% 
% M1_hr=M1(1:hr_freq_stop(1));
% M1_resp=M1(hr_freq_stop(1):resp_freq_stop(1));
% M1_myo=M1(resp_freq_stop(1):myo_freq_stop(1));
% M1_neur=M1(myo_freq_stop(1):neur_freq_stop(1));
% M1_eMeta=M1(neur_freq_stop(1):end);
% 
% [hr_peak,locs_hr]=findpeaks(M1_hr);
% [resp_peak,locs_resp]=findpeaks(M1_resp,'SortStr','descend');
% [myo_peak,locs_myo]=findpeaks(M1_myo,'SortStr','descend');
% [neur_peak,locs_neur]=findpeaks(M1_neur,'SortStr','descend');
% [eMeta_peak,locs_eMeta]=findpeaks(M1_eMeta,'SortStr','descend');

[hr_peak,locs_hr,hr_freq,M1_hr,resp_peak,locs_resp,resp_freq,M1_resp,myo_peak,locs_myo,myo_freq,M1_myo,...
    neur_peak,locs_neur,neur_freq,M1_neur,eMeta_peak,locs_eMeta,eMeta_freq,M1_eMeta] = findPeaks_CWT(cwt1,M1);

figure(2)
subplot(2,1,1)
semilogx(cwt1.frequencies,M1),hold on
plot(hr_freq(locs_hr),hr_peak,'rv','MarkerFaceColor','r')
plot(resp_freq(locs_resp(1)),resp_peak(1),'rv','MarkerFaceColor','r')
plot(myo_freq(locs_myo),myo_peak,'rv','MarkerFaceColor','r')
plot(neur_freq(locs_neur),neur_peak,'rv','MarkerFaceColor','r')
plot(eMeta_freq(locs_eMeta),eMeta_peak,'rv','MarkerFaceColor','r')
hold off
subplot(2,1,2)
semilogx(resp_freq,M1_resp), hold on
plot(resp_freq(locs_resp(1)),resp_peak(1),'rv','MarkerFaceColor','r')
hold off

