load('Test_20160204.mat')
LDF=data(datastart(5,1):dataend(5,1));
LDF_2=data(datastart(5,2):dataend(5,2));
LDF=[LDF LDF_2];
LDF=LDF-mean(LDF);
fs=samplerate(1,1);
t=0:1/fs:length(LDF)/fs-1/fs;

min10=10*60; min20=20*60; min30=30*60; min40=40*60; min50=50*60;

ECG=LDF;


%%
range=[1 min10];
[ECG_exc,t,fs,sig_name]=signal_exc(ECG,'ECG',range,400);

[ECG_w,t1_w,fs1_w,lvl1]=wavedecom(ECG_exc,t,fs,5,'db4');

cwt_morl=cwtAnalysis(ECG_w,fs1_w,0.01,3,'morl');
cwt_bump=cwtAnalysis(ECG_w,fs1_w,0.01,3,'bump');
cwt_dog=cwtAnalysis(ECG_w,fs1_w,0.01,3,'dog');
cwt_paul=cwtAnalysis(ECG_w,fs1_w,0.01,3,'paul');

M_morl=mean(abs(cwt_morl.cfs),2);
M_bump=mean(abs(cwt_bump.cfs),2);
M_dog=mean(abs(cwt_dog.cfs),2);
M_paul=mean(abs(cwt_paul.cfs),2);

figure(1)
subplot(4,1,1)
semilogx(cwt_morl.frequencies,abs(M_morl))
title('CWT of LDF')
axis([0.01 2 -inf inf])
legend('morl')
xlabel('Hz')
subplot(4,1,2)
semilogx(cwt_bump.frequencies,abs(M_bump))
legend('bump')
axis([0.01 2 -inf inf])
xlabel('Hz')
subplot(4,1,3)
semilogx(cwt_dog.frequencies,abs(M_dog))
legend('dog')
axis([0.01 2 -inf inf])
xlabel('Hz')
subplot(4,1,4)
semilogx(cwt_paul.frequencies,abs(M_paul))
legend('paul')
axis([0.01 2 -inf inf])
xlabel('Hz')

